package httpServer;

import java.io.IOException;

import java.io.InputStream;
import java.io.OutputStream;

import javax.microedition.io.CommConnection;
import javax.microedition.io.Connector;

public class Tc65SerialPort 
{
	CommConnection	commConn;
	InputStream   	inStream;
	OutputStream  	outStream;

	public Tc65SerialPort()
	{
        try 
        {
//			String strCOM = "comm:com0;blocking=on;baudrate=115200";
			String strCOM = "comm:com0;blocking=on;baudrate=115200;autocts=off;autorts=off";
			commConn = (CommConnection)Connector.open(strCOM);
			inStream  = commConn.openInputStream();
			outStream = commConn.openOutputStream();
		} 
        catch (IOException e) 
        {
			e.printStackTrace();
		}
	}

	public boolean Open()
	{
		boolean bOpen = false;
        try 
        {
			String strCOM = "comm:com0;blocking=on;baudrate=115200;autocts=off;autorts=off";
			commConn = (CommConnection)Connector.open(strCOM);
			inStream  = commConn.openInputStream();
			outStream = commConn.openOutputStream();
			bOpen = true;
		} 
        catch (IOException e) 
        {
			e.printStackTrace();
		}
        
        return bOpen;
	}

	public void SetBaudRate(int baudrate)
	{
		commConn.setBaudRate(baudrate);
	}
	
	public void Close()
	{
		try{inStream.close();}catch (IOException e){e.printStackTrace();}
		try{outStream.close();}catch (IOException e){e.printStackTrace();}
		try{commConn.close();}catch (IOException e){e.printStackTrace();}
	}
	
	/**
	 *    -
	 * @param s - String
	 */
	public void serialOut(String s)
	{
		serialOut(s.getBytes());
	}
	/**
	 *    -
	 * @param b - byte[] array
	 */
	public void serialOut(byte[] b)
	{
		try
		{
			outStream.write(b);
		}
		catch(IOException e)
		{
			System.out.println(e);
		}
	}

	/**
	 *     -
	 * @param b - byte[] array
	 */
	public void serialOut(char c)
	{
		try
		{
			outStream.write(c);
		}
		catch(IOException e)
		{
			System.out.println(e);
		}
	}
	
	public int hasData()
	{
		int n = 0;
		try 
		{
			n = inStream.available();
		} 
		catch (IOException e) 
		{
		}
		
		return n;
	}
	
	int readByte()
	{
		int NextByte = -1;
		try {
			NextByte = inStream.read();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return NextByte;
	}

	boolean writeByte(byte b)
	{
		boolean bOk = false;
		try {
			outStream.write(b);
			bOk = true;
		} catch (IOException e) {
			e.printStackTrace();
			bOk = false;
		}
		return bOk;
	}

	boolean write(byte[] array, int len)
	{
		boolean bOk = false;
		try {
			outStream.write(array, 0, len);
			bOk = true;
		} catch (IOException e) {
			e.printStackTrace();
			bOk = false;
		}
		return bOk;
	}
}
